<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUniqueID_Type ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfUniqueID_Type extends AbstractStructArrayBase
{
    /**
     * The ProfileRef
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgUniqueID_Type[]
     */
    public $ProfileRef;
    /**
     * Constructor method for ArrayOfUniqueID_Type
     * @uses DgArrayOfUniqueID_Type::setProfileRef()
     * @param \dgsoft\StructType\DgUniqueID_Type[] $profileRef
     */
    public function __construct(array $profileRef = array())
    {
        $this
            ->setProfileRef($profileRef);
    }
    /**
     * Get ProfileRef value
     * @return \dgsoft\StructType\DgUniqueID_Type[]|null
     */
    public function getProfileRef()
    {
        return $this->ProfileRef;
    }
    /**
     * Set ProfileRef value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgUniqueID_Type[] $profileRef
     * @return \dgsoft\ArrayType\DgArrayOfUniqueID_Type
     */
    public function setProfileRef(array $profileRef = array())
    {
        foreach ($profileRef as $arrayOfUniqueID_TypeProfileRefItem) {
            // validation for constraint: itemType
            if (!$arrayOfUniqueID_TypeProfileRefItem instanceof \dgsoft\StructType\DgUniqueID_Type) {
                throw new \InvalidArgumentException(sprintf('The ProfileRef property can only contain items of \dgsoft\StructType\DgUniqueID_Type, "%s" given', is_object($arrayOfUniqueID_TypeProfileRefItem) ? get_class($arrayOfUniqueID_TypeProfileRefItem) : gettype($arrayOfUniqueID_TypeProfileRefItem)), __LINE__);
            }
        }
        $this->ProfileRef = $profileRef;
        return $this;
    }
    /**
     * Add item to ProfileRef value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgUniqueID_Type $item
     * @return \dgsoft\ArrayType\DgArrayOfUniqueID_Type
     */
    public function addToProfileRef(\dgsoft\StructType\DgUniqueID_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgUniqueID_Type) {
            throw new \InvalidArgumentException(sprintf('The ProfileRef property can only contain items of \dgsoft\StructType\DgUniqueID_Type, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfileRef[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgUniqueID_Type|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgUniqueID_Type|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgUniqueID_Type|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgUniqueID_Type|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgUniqueID_Type|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileRef
     */
    public function getAttributeName()
    {
        return 'ProfileRef';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfUniqueID_Type
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
